// FONCTIONS FICHIERS 
//-------------------------------------------------------------
void initsdcard() {               // initialisation de la carte SD   
   if (SD.begin(SDSSPIN)) {
     sdok = true;                 // indic présence de carte SD
     #if TRACE
       Serial.println("Initialisation carte SD OK"); 
     #endif
   }
    else {                        // absence de carte SD 
      #if TRACE
        Serial.println("Echec initialisation carte SD");  // message port Série 
      #endif
      erreur_SD();       
  }
}

//-------------------------------------------------------------
void ouvhistoecr() {                           //  création du fichier historique de saisie
  fichier6 = SD.open("/HISTO.txt", FILE_READ); // test présence du fichier
  if (!fichier6) {
    fichier6 = SD.open("/HISTO.txt", FILE_WRITE); // crée le fichier s'il n'existe pas 
    if (!fichier6) {                          // test si OK
      erreur_SD();                            // erreur creation fichier 
    }
  }
  else {
    fichier6.close(); 
    fichier6 = SD.open("/HISTO.txt", FILE_APPEND); // ouvre le fichier en ajout s'il existe  
    if (!fichier6) {                               // test si OK
      erreur_SD();                                 // erreur creation fichier
    }
  } 
}

//-------------------------------------------------------------
void enrsaisie() {                  // enregitrement d'une saisie (enregt de 24 car)
  ouvhistoecr();
  String enr = "";
  rtc.read();        
  sprintf(timestamp, "%04d%02d%02d;%02d%02d%02d;%01d", rtc.year,rtc.month,rtc.day,rtc.hour,rtc.minute,rtc.second,rtc.week);       
  enr = enr + timestamp;
  enr = enr + (";");
  enr = enr + typenr;
  enr = enr + (";");
  fichier6.println(enr);
  #if TRACE
    Serial.println("Enregitrement d'une saisie sur carte SD = "); 
    Serial.println(enr);
  #endif
  closhisto();
}

//-------------------------------------------------------------
void closhisto() {    
  fichier6.close();                     // fermeture du fichier histo
  #if TRACE
    Serial.println("Fermeture du fichier histo"); 
  #endif
}

//-------------------------------------------------------------
void creselectecr() {    
  fichier7 = SD.open("/SELEC.txt", FILE_WRITE); // crée le fichier 
  if (!fichier7) {                              // test si OK
    #if TRACE
      Serial.println("Echec ouverture en ecriture fichier sélection");  
    #endif  
    erreur_SD();                                // erreur creation fichier 
  }
  fichier7.println("Date AAAAMMJJ;Heure HHMMSS;jour sem.;Visite/appel;");    // en-tête de fichier
}

//-------------------------------------------------------------
void ouvseleclec() {                  //  ouverture en lecture du fichier de séléction
  fichier7 = SD.open("/SELEC.txt", FILE_READ);  // test présence du fichier
  if (!fichier7) {
    #if TRACE
      Serial.println("Echec ouverture en lecture fichier selection depuis historique");  
    #endif  
  }
}

//-------------------------------------------------------------
void closelect() {    
  fichier7.close();                     // fermeture du fichier sélection 
  #if TRACE
    Serial.println("Fermeture du fichier /SELEC.txt"); 
  #endif
}

//-------------------------------------------------------------
void effselec() {             // effacer fichier selection depuis historique
  SD.remove("/SELEC.txt");  
  #if TRACE
    Serial.println("Effacement du fichier /SELEC.txt"); 
  #endif
}

//-------------------------------------------------------------
void ouvhistolec() {                   //  ouverture en lecture du fichier historique de saisie
  fichier6 = SD.open("/HISTO.txt", FILE_READ);  // test présence du fichier
  if (!fichier6) {
    #if TRACE
      Serial.println("Echec ouverture en lecture fichier historique"); 
    #endif   
    erreur_SD();                      // erreur lecture fichier  
  }
}

//-------------------------------------------------------------
void ouvarchivecr() {                           //  création du fichier archives
  fichier4 = SD.open("/ARCHI.txt", FILE_READ); // test présence du fichier
  if (!fichier4) {
    fichier4 = SD.open("/ARCHI.txt", FILE_WRITE); // crée le fichier s'il n'existe pas 
    if (!fichier4) {                          // test si OK
      erreur_SD();                            // erreur creation fichier 
    }
    else {
      fichier4.println("Date AAAAMMJJ;Heure HHMMSS;jour sem.;Visite/appel;");    // en-tête de fichier
    }
  }
  else {
    fichier4.close(); 
    fichier4 = SD.open("/ARCHI.txt", FILE_APPEND); // ouvre le fichier en ajout s'il existe  
    if (!fichier4) {                               // test si OK
      erreur_SD();                                 // erreur creation fichier
    }
  } 
}

//-------------------------------------------------------------
void cloarchiv() {    
  fichier4.close();                     // fermeture du fichier sélection 
  #if TRACE
    Serial.println("Fermeture du fichier /ARCHI.txt"); 
  #endif
}

//-------------------------------------------------------------
void renomhisto() {                   // renommer le fichier historique après archivage
  Serial.println("Renommage ancien fichier historique"); 
  rtc.read();
  sprintf(datew, "%02d%02d", rtc.year - 2000, rtc.month); 
  for (int i = 2; i < 6; i++)  {
      nomfich3[i] = datew[i - 2];            // nom fichier histo apres archive = /HYYMM.txt
    }  
  Serial.print("/HISTO.txt");    
  Serial.print("  à renommer en  ");     
  Serial.println(nomfich3);         
  if (!SD.rename("/HISTO.txt", nomfich3)) {  //renommage du fichier histo et test si OK
    erreur_SD();                                // erreur de renommage
  }             
}

//-------------------------------------------------------------
void renomselect() {                   // renommer le fichier historique après archivage
  Serial.println("Renommage du fichier select en /HISTO.txt"); 
  rtc.read();
  sprintf(datew, "%02d%02d", rtc.year - 2000, rtc.month); 
  for (int i = 2; i < 6; i++)  {
      nomfich3[i] = datew[i - 2];            // nom fichier histo apres archive = /HYYMM.txt
    }  
  Serial.print("/SELEC.txt");    
  Serial.print("  à renommer en  ");     
  Serial.println("/HISTO.txt");          
  if (!SD.rename("/SELEC.txt", "/HISTO.txt")) {  //renommage du fichier et test si OK
    erreur_SD();                                // erreur de renommage
  }             
}
//-------------------------------------------------------------
void comptasaisie() {       // décompte de la saisie par mois pour affichage sur écran d'accueil
  blocsaisie();                            // blocage de la saisie
  cptenr = 0;                              // comptage total enregts
  cptper = 0;                              // nb enregts dans la période traitée (12 mois préc)
  cptold = 0;                              // nb enregts antérieurs à la période traitée (inf à 12 mois préc)
  int anenr;
  int moisenr;
  String enreg = "";                        // mise du buffer enregistrement à vide    
  anprec = anec - 1; 
  fichier1 = SD.open("/HISTO.txt",FILE_READ);   // ouvre le fichier historique des saisies en lecture
  if (fichier1) {                           //  un fichier de saisie existe
    while (fichier1.available()) {
      enreg = fichier1.readStringUntil('\n'); 
      cptenr++;                           // +1 comptage nb enregistrements
      if (cptenr > 1) {                   // on saute le premier enregt (en-tête)
        anenr = enreg.substring(0,4).toInt();
        if ((anenr == anec) || (anenr == anprec)) {
          moisenr = enreg.substring(4,6).toInt();
          for (i = 0; i < 13; i++) {      // on compte aussi la saisie du mois
            if ((anenr == tans[i]) && (moisenr == tmois[i])) {
              cptper++;                         // ... + saisies de la période affichée
              if (enreg.substring(18,19) == "V")  nbvis[i]++;
              else if (enreg.substring(18,19) == "A")  nbapp[i]++;
            }
          }
        }
      }
      enreg = "";
    } 
  }
  cptenr--;                            // ne pas compter l'en-tête
  cptold = cptenr - cptper;            // comptage enrgts antérieurs à la période traitée
  #if TRACE
    Serial.print("Nb total enregts dans histo : "); 
    Serial.print(cptenr); 
    Serial.print("  Nb enregts dans période : "); 
    Serial.print(cptper); 
    Serial.print("  Nb enregts antérieurs à période : "); 
    Serial.println(cptold); 
    afftablecumuls();
  #endif 
  deblocsaisie();                         // déblocage de la saisie 
}

//-------------------------------------------------------------
void lecparam() {              // si fichier PARAM présent, il modifie les valeurs par défaut
//    fichier PARAM contient 2 enregitrements :
//                  SSID<nom du réseau Wifi local>          50 car.maxi      
//                  PWRD<mot de passe du réseau local>     100 car.maxi 
  #if TRACE 
    Serial.println("Lecture fichier paramètres wifi"); 
  #endif 
  char c; 
  String regcode = ""; 
  String readstring = "";   
  bool presdata = true;                      
  fichier5 = SD.open("/PARAM.txt",FILE_READ); // ouverture en lecture du fichier paramètres     
  if (fichier5) {                             // si fichier présent (fichier facultatif)                                                      
    while (presdata) {   
      regcode = "";
      readstring = "";                              
      for (int i = 0; i < 4; i++) {           // identif enregt = 4 char.
        c = fichier5.read();
        regcode += c ;                        // concatenation du code enregt
      }
      c = fichier5.read();                    // saut du séparateur de début de champ "<"
      while (c != '>')  {
        c = fichier5.read();
        if (c != '>')  { 
          readstring += c;
        }    
      }
      while (c != '\n') {                     // jusqu'à la fin de l'enregistrement,....
        c = fichier5.read();                  // .. lire le reste des caratères non utilisés 
      }
      if (regcode == "SSID") {
        readstring.toCharArray(ssid,readstring.length()+1);
      }
      if (regcode == "MOPA") {
        readstring.toCharArray(password,readstring.length()+1);
        presdata = false;
      }
    }
    fichier5.close();
    #if TRACE
      Serial.print("SSID = ");
      Serial.println(ssid);
      Serial.print("PWD = ");
      Serial.println(password);
      Serial.print("Port = ");
      Serial.println(port);
    #endif
  }
  else {     
    #if TRACE              
      Serial.println("Il n'y a pas de fichier paramètres (PARAM.txt)");
    #endif
  }
}

//-------------------------------------------------------------
