// FONCTIONS de téléchargement d'une séléction à partir de l'historique
//----------------------------------------------------------------------------------- 
void uploadselec() {         // téléchargement du fichier de sélection dans historique
  #if TRACES
    Serial.println("Téléchargement du fichier /SELEC.txt");
    Serial.print("Nom fichier transfert : ");
    Serial.println(nomtransf);
  #endif 
  int taillefich = fichier7.size(); 
  page = "";
  page += "HTTPS/1.1 200 OK\r\n";
  page += "<meta http-equiv='Content-Security-Policy' content='upgrade-insecure-requests'>";
  page += "Content-Type: text/plain\r\n";
  page += "Content-Disposition: attachment; filename=" + nomtransf + "\r\n";
  page += "Content-Length: " + String(taillefich) + "\r\n";
  page += "\r\n";
  server.sendContent(page);  // on transfère tout le fichier par blocs de 128 octets 
  char buffer[128];
  while (taillefich > 0) {   // ...jusqu'à la fin du fichier
    size_t longueur = std::min((int)(sizeof(buffer)), taillefich);
    fichier7.read((uint8_t *)buffer, longueur);                       
    server.client().write((const char*)buffer, longueur);         
    taillefich = taillefich - longueur;
    server.sendContent(""); 
  } 
}

//-------------------------------------------------------------  
void recuhisto()  {
  debsel = dadeb.substring(2,4) + dadeb.substring(5,7) + dadeb.substring(8,10);
  finsel = dafin.substring(2,4) + dafin.substring(5,7) + dafin.substring(8,10);
  dselaff = dadeb.substring(8,10) + "/" + dadeb.substring(5,7) + "/" + dadeb.substring(0,4);
  fselaff = dafin.substring(8,10) + "/" + dafin.substring(5,7) + "/" + dafin.substring(0,4);
  dselfic = dadeb.substring(8,10) + dadeb.substring(5,7) + dadeb.substring(2,4);
  fselfic = dafin.substring(8,10) + dafin.substring(5,7) + dafin.substring(2,4);
  int debint = debsel.toInt();
  int finint = finsel.toInt();
  #if TRACES
    Serial.print("Création fichier de sélection du ");
    Serial.print(dadeb);
    Serial.print(" au ");
    Serial.println(dafin);
  #endif
  effselec();
  blocsaisie();                            // blocage de la saisie
  ouvhistolec();
  creselectecr();
  cptenr = 0;
  String enreg = "";
  String datenr = "";
  int datenreg = 0;
  while (fichier6.available()) {
    enreg = fichier6.readStringUntil('\n');  
    datenr = enreg.substring(2,8); 
    datenreg = datenr.toInt();     
    if ((datenreg >= debint) && (datenreg <= finint))  {
      cptenr++;                            // +1 comptage nb enregistrements
      fichier7.print(enreg);      
    }  
  }
  deblocsaisie();                         // déblocage de la saisie 
  closelect(); 
  #if TRACES
    Serial.print("Nb enregistrements sélectés : ");
    Serial.println(cptenr);
  #endif  
  delay(500);
}
 
//---------------------------------------------------------
void pageperiod() { 
  page = "";
  page += F("<!DOCTYPE html><html lang=fr-FR><head>");
  page += F("<meta charset='UTF-8'>");
  page += F("<title>Accueil</title>");
  page += F("<style type='text/css'> A{text-decoration:none;}");
  page += F("h1 {font-family: Helvetica; margin: 0px auto; text-align: center; font-size: 47pt;}");
  page += F("h2 {font-family: Helvetica; margin: 0px auto; text-align: center; font-size: 35pt;}");
  page += F("h3 {font-family: Helvetica; margin: 0px auto; text-align: center; font-size: 20pt;}");
  page += F("button1 {background-color: black; color: yellow; font-weight:bold; font-size: 30px;  border-radius:15px;");
  page += F(" padding:10px; border: 5px yellow solid; }");    
  page += F("button2 {background-color: yellow; color: black; font-weight:bold; font-size: 40px; ");
  page += F(" margin-right: 20px; float:right;}");  
  page += F("</style></head>");
  page += F("<body><style>body {min-height: 90%;margin: 0;padding: 10px;font-family: Arial; Color: yellow;}</style>");
  page += F("<div align='center' style='width:950px;height:720px;border: yellow solid; background-color:black;'>");
  page += F("<ul><h1>");
  page += F("<li>Visites & appels AVH  </h1><h2>");
  page += F("<br />");
  page += F("<li>Téléchargement pour une période");
  page += F("<br />");
  if (cptenr == -1) {              // si première demande ou si aucune sélection
    page += F("<form action='/submit' method='get'>");
    page += F("<br /><li>Date début période : <input type='date' style='width:250px;height:40px;font-size:35px' name='datedebut' autofocus>");
    page += F("<br /><br /><li>Date fin période : <input type='date' style='width:250px;height:40px;font-size:35px' name='datefin'>");
    page += F("&nbsp;&nbsp;<input type='submit' style='width:150px;height:45px;font-size:35px'></form>");
  }
  else {
    page += F("<form action='/' method='POST'>");
    page += F("<li>Du   ");
    page += dselaff;
    page += F("  au  ");
    page += fselaff;
  }
  if (cptenr == 0) {
    page += F("<br />");
    page += F("<li>Aucune sélection pour cette période.");
  }
  else { 
    if (cptenr > 0) {
      page += F("<li>Sélection de "); 
      page +=  cptenr;
      page += F(" enregistrements."); 
      page += F("<br /><br />");
      page += F("<button1><a href='charghis'><font color='yellow'>Télécharger</font></button1></a>");
    }
  }
  page += F("<br /><br /><br />");
  page += F("<button1><a href='/'><font color='yellow'>Retour accueil</font></button1></a>");
  page += F("</h2></ul>"); 
  page += F("</body>");       
}

//=======================================================================
void demandperiod() {
  cptenr = -1;        // pour bloquer messages résultant de la selection
  pageperiod(); 
  #if TRACES
    Serial.println("Demande dates début et fin de la période");
  #endif
  inselmois = false;
  server.send(200, "text/html", page);
}

//-------------------------------------------------------------
void selechisto() {
  indmois = -1;
  i = 0;
  if (inselmois) {
    moisselec = server.arg("choixmois").toInt();
    do { 
      if (tmois[i] == moisselec) {
        indmois = i;
        transfertmois();
      } 
      i++;
    } while (i < 12);
  }
  else {
    dadeb = server.arg("datedebut");
    dafin = server.arg("datefin");
  }
  recuhisto();
  nomtransf = "PER_" + debsel + "_" + finsel + ".csv";
  pageperiod();
  server.send(200, "text/html", page);
}

//-------------------------------------------------------------
void chargehisto() { 
  ouvseleclec();
  uploadselec();     // téléchargement de la sélection faite dans l'historique
  delay(200);
}

//-------------------------------------------------------------